var updateMessages = function(messages, area) {
    jQuery( "#system-message-container #system-message ."+area+"-message").remove();
    // Extract the messages from the returned string, add the ordernumber-message class (so the next ajax call
    // can remove them again) and then move the messages to the original message container.
    // Things are complicated by the fact that no #system-message element exists if no messages were printed so far
    var newmessages = jQuery( messages ).find("div.alert, .message").addClass(area+"-message");
    if (!jQuery( "#system-message-container #system-message").length && newmessages.length) {
        if (jQuery(newmessages).first().prop("tagName")=="dt") { // Joomla 2.x:
            jQuery( "#system-message-container" ).append( "<dl id='system-message'></div>" );
        } else {
            jQuery( "#system-message-container" ).append( "<div id='system-message'></div>" );
        }
    }
    newmessages.appendTo( "#system-message-container #system-message");
}
var getCounterData = function (btn) {
    var row=jQuery(btn).parents("tr.counter_row");
    return { row: row };
}
var handleJSONResponse = function (json, counter) {
    updateMessages(json['messages'], "ordernumber");
    if (!json.authorized) {
        alert("You are not authorized to modify order number counters.");
    } else if (json.error) {
        alert(json.error);
    } else {
        // TODO: Which other error checks can we do?
    }
}
var ajaxEditCounter = function (btn, nrtype, ctr, value) {
    var counter = getCounterData(btn);
    counter.type=nrtype;
    counter.counter=ctr;
    counter.value=value;
    var value = NaN;
    var msgprefix = "";
    while (isNaN(value) && (value != null)) {
        value = prompt (msgprefix+"Please enter the new value for the counter '" + counter.counter + "' (current value: " + counter.value + "):", counter.value);
        if (value != null)
            value = parseInt(value);
        if (isNaN(value)) 
            msgprefix = "You entered an invalid value for the counter.\n\n";
    }
    if (value != null) {
        var loading = jQuery("img.vm-ordernumber-loading").first().clone().insertAfter(btn).show();
        jQuery.ajax({
            type: "POST",
            cache: false,
            dataType: "text", // Read text, but interpret as JSON later in the done method (prevents a warning!)
            url: "index.php?option=com_virtuemart&view=plugin&type=vmshopper&name=ordernumber&action=setCounter&format=raw",
            data: { nrtype: counter.type, counter: counter.counter, value: value },
            success: function( data ) {
                var json = data ? jQuery.parseJSON(data) : null;
                handleJSONResponse(json, counter);
                if (json.success>0) {
                    jQuery(counter.row).children(".counter_value").text(value);
                } else {
                    alert ("Failed modifying counter "+counter.counter);
                }
            },
            error: function() { alert ("ERROR: Failed modifying counter "+counter.counter); },
            complete: function() { jQuery(loading).remove(); },
        });
    }
}
var ajaxDeleteCounter = function (btn, nrtype, ctr, value) {
    var counter = getCounterData(btn);
    counter.type=nrtype;
    counter.counter=ctr;
    counter.value=value;
    var proceed = confirm ("Really delete counter '"+counter.counter+"' with value '"+counter.value+"'?");
    if (proceed == true) {
        var loading = jQuery("img.vm-ordernumber-loading").first().clone().insertAfter(btn).show();
        jQuery.ajax({
            type: "POST",
            cache: false,
            dataType: "text", // Read text, but interpret as JSON later in the done method (prevents a warning!)
            url: "index.php?option=com_virtuemart&view=plugin&type=vmshopper&name=ordernumber&action=deleteCounter&format=raw",
            data: { nrtype: counter.type, counter: counter.counter },
            success: function( data ) {
                var json = data ? jQuery.parseJSON(data) : null;
                handleJSONResponse(json, counter);
                if (json.success>0) {
                    jQuery(counter.row).fadeOut(1500, function() { $(this).remove(); });
                } else {
                    alert ("Failed modifying counter "+counter.counter);
                }
            },
            error: function() { alert ("ERROR: Failed modifying counter "+counter.counter); },
            complete: function() { jQuery(loading).remove(); },
        });
    }
}
var ajaxAddCounter = function (btn, nrtype) {
    var row = jQuery(btn).parents("tr.addcounter_row");
    var countername = prompt ("Please enter the format/name of the new counter:");
    if (countername != null) {
        var loading = jQuery("img.vm-ordernumber-loading").first().clone().insertAfter(jQuery(btn).find("img.vmordernumber-counter-addbtn")).show();
        jQuery.ajax({
            type: "POST",
            cache: false,
            dataType: "text", // Read text, but interpret as JSON later in the done method (prevents a warning!)
            url: "index.php?option=com_virtuemart&view=plugin&type=vmshopper&name=ordernumber&action=addCounter&format=raw",
            data: { nrtype: nrtype, counter: countername },
            success: function( data ) {
                var json = data ? jQuery.parseJSON(data) : null;
                handleJSONResponse(json, { type: nrtype, counter: countername, value: 0, row: row });
                if (json.success>0) {
                    if (json.newrow) {
                        jQuery(row).before(jQuery(json.newrow));
                    }
                }
            },
            error: function() { alert ("ERROR: Failed adding counter "+countername); },
            complete: function() { jQuery(loading).remove(); },
        });
    }
}
